.TH ADD C
.DA 5 May 1992
.SH Name
add - Append files
.SH Syntax
add _file_... _target_
.SH Description
Use _add_ to append one or more files to a target file. The source
file(s) may be in another directory, in which case a path must be given.
.PP
If the _target_ is a directory, the source _files_ are added to files
in the _directory_ using their original filenames.
.PP
If the _target_ file does not exist, it is created, and the contents
of the source files are appended.
.PP
If a source _file_ is given, but no target _file_ argument, the current
working directory is assumed as the target area, preserving the original
filename, though _add_ refuses to add a file to itself.
.PP Example
.IP 5
.AF
add stratos.5 ../mdavis/stratos.novel
.AF
.IP
This adds the file ``stratos.5'', assuming the current directory is
$/usr/brin, to the file ``stratos.novel'' in the ``$/usr/mdavis''
directory.  If ``stratos.novel'' was omitted, the original filename
``stratos.5'' would have been used.
.SH See Also
cat(C), cp(C), mv(C)
