.TH CHAT C
.DA 6 May 1992
.SH Name
chat - Chat mode
.SH Syntax
chat [ -r _rings_ ] [ -t ] [-v _volume_ ]
.SH Description
_Chat_ lets a caller and the system operator carry on conversation in
real time.  Upon invoking _chat_, an audible signal (much like a
telephone) rings on the host computer.  If the operator is available,
the chat request is serviced, placing the user and the operator into a
chat mode. If the operator is not available, the user is given
the chance to send an electronic mail letter instead.
.PP
Depending on the type of terminal the user emulates, one of two
chat modes may be invoked. Both modes offer word wrap and limited text
editing.
.PP
With terminal emulation, a split-screen mode is activated.  The user and
operator have their own windows in which to type messages unencumbered
by the other's input.  In fact, each may type at the same time without
interrupting the other. Typing Control-L redraws the entire screen.
Typing Control-X clears the user's or operator's assigned window. 
Pressing the Escape key exits the _chat_ program.
.PP
If no terminal emulation is set up, a regular chat loop is activated. 
In this mode, the user and operator must take turns entering lines of
text so as not to ``step on'' one another.  Standard chat protocol in this
method involves pressing RETURN enough times to put at least one blank
line after a typed message is completed.  This signals the other user
that a response is expected.  Entering a period alone on a new line
exits the _chat_ program.
.PP
The options are:
.IP 10 -r N
Rings (default = 6), where N is the number of ``phone rings''
that sound before _chat_ gives up.
.IP 10 -t
TTY mode (no split-screen emulation), even if adequate emulation is enabled.
.IP 10 -v N
Volume level (default = 7), where N is a number from 0 (quiet) to 15 (loudest) which
controls the loudness of the ringing signal at the console.
Only the super user may specify this option.
.IP
.PP Operator's Note
.BR
To regulate chatting times, hooking up a joystick or game paddle to the
computer provides an ``availability switch''. Moved to the left,
chatting is disabled (you have ``left'').  Moved to
the right, chatting is enabled (you are ``right'' there).
