.TH NEWS C
.DA 28 January 1994
.SH Name
news - System news bulletins
.SH Syntax
news [ _options_ ] [ -t _item_ ] [ _items_... ]
.SH Description
_News_ displays and manages system news bulletins (not to be confused
with USENET news).  These bulletins are created by the
system administrator reporting important news about the system.
.PP
Without arguments, _news_ displays any items that are new since
the user's last session.  New items are considered new for the
entire session.  In other words, each time _news_ is invoked, the same
new items are shown until the user logs out.
.PP
An interactive mode (-i option) allows users and the administrator to
browse all news items.  The administrator can also create, delete, and
edit items interactively.
.PP
_News_ recognizes a number of command line options discussed below.
News _item_ arguments given in the command line can be the item's index
number, its corresponding file name, or the subject that references
the item.  (When referencing an item by subject, enclose it within
quotes if it contains spaces).
.PP Options:
.IP 10 -a
All items.  Causes _news_ to consider all items new (unseen).
.IP 10 -c
Disable cancel keys.  During the display of news items in non-interactive
mode, cancel keys have no effect.  This also forces a --More-- prompt
at the end of each item causing the user to acknowledge it before
continuing.
.IP 10 -i
Interactive mode.  Various commands can be entered interactively.
Type ? for a list of commands.
.IP 10 -n
News item list.  This lists all items, showing their index numbers,
file names, dates, and subjects.
.IP 10 -s
Reports only a count of the number of news items that exist.
.IP 10 -t item
Touches (updates) a news item, making it the newest item.  This is
useful for resurrecting an old item and making it new news.
.IP
While in interactive mode, only the super user can delete, edit, or
add news items.
.SH Notes
Editing a news item does _not_ make it new.
.PP
_News_ should be invoked whenever a user signs on.  This is not done
automatically by the _login_ program, as in older versions of ProLine.
See csh(C) for details on the _cshrc_ script where an entry for _news -c_
makes good sense.
.SH Files
$/sys/news/* - news files.
.SH See Also
csh(C), mcinews(C)
