.TH PS C
.DA 18 October 1993
.SH Name
ps - Report process status
.SH Syntax
ps [ -defhmu ] [ -j _id_ ] [ -k _id_ ] [ -l _module_ ]
.SH Description
_Ps_ reports system module and active user processes.  Without options,
the -u flag is assumed.
.PP
Options are:
.IP 10 -d | -h
Select module information display format: decimal (-d) or hexadecimal (-h).
.IP 10 -e
Show everything.  A list of user (-u) processes and system modules (-m)
are both shown.
.IP 10 -f
Full information.  Lists are displayed with as much information as
possible.  With this option, full pathnames are displayed with -u.
.IP 10 -m
Show modules.  Each entry gives a module's index and ID number,
size, address in memory, modification date, name and version number.
.IP 10 -u
Show user processes. (default)
.IP 10 -j id
Show information for one module where _id_ is either its index or
ID (in decimal).
.IP 10 -k id
Kill a module where _id_ is either its index or ID (in decimal).  See Warning.
Super user only.
.IP 10 -l module
.BR
Load _module_ by name.  If the _module_ name contains no slashes, it is
assumed to reside in $/sys/modules. Super user only.
.IP
.SH Warning
Killing system-dependent modules can have unfortunate results.
Loading modules indiscriminately can cause serious memory errors.
.SH Files
$/sys/modules/*
.SH See Also
boot(ADM)
