.TH SWEEP C
.DA 2 November 1993
.SH Name
sweep - File utility
.SH Syntax
sweep [ _directory_ ]
.SH Description
_Sweep_ is patterned after the popular CP/M SWEEP utility which allows you to
manipulate files with much ease.  _Sweep_ lets you to perform many
different disk-related operations on single files as well as on batches of
files.
.PP
To operate on a single file, simply advance to the file entry you desire and
then press a command key.
.PP
To operate on a batch of files, advance to each file desired, "tag" it, and
then press the letter of the command you want to perform on those files.
.PP
When _sweep_ is invoked it first displays a help screen, and then reads all
the filenames from the current working directory.  If you use a directory
name with _sweep_, as in _sweep $/pub/stuff_, the working directory is
changed to the new directory.
.PP
At this point you may use any of the following commands:
.LM 5
.IP 5 T
tag a file (use control-T to tag all files)
.IP 5 U
untag a file (use control-U to untag all files)
.IP 5 D
delete the selected file(s)
.IP 5 C
copy the selected file(s)
.IP 5 M
move the selected file(s).  This is the same as a copy followed by a
delete. 
.IP 5 V
view the selected file(s).
.IP 5 P
go to previous file in the list.
.IP 5 ^P
go to the previous directory.  After pressing ^P you
can type RETURN to select the prompted directory, or edit the path
presented to you to go to a different area.
.IP 5 L
change to a new directory location.  If you're currently sitting next to a
subdirectory entry in the file list, pressing L RETURN changes to that
directory.
.IP 5 A
alters protection attributes for the selected file(s).  This allows you to
``lock'' or ``unlock'' a file.
.IP 5 S
toggles _sweep_'s list sorting feature.  _Sweep_ comes up initially with
all the files in the list sorted alphabetically.
.IP 5 E
edit the selected file(s).  The editor you select using the _setenv_ command
is used.
.IP 5 R
rename the selected file(s).
.IP 5 Q
quit _sweep_ and return to the shell.
.IP 5 N
create a new directory in the current directory.  Enter the name of the
new directory when prompted.
.IP 5 ?
display the command list
.IP
.LM -5
Any key other than those listed will advance you from the current entry
to the next one.  If you're at the last entry in this list,
advancing will take you back to the first entry.  Similarly,
retreating beyond the first entry will take you to the
last entry in the list.
.PP
When supplying the target path for a copy or a move, simply give the name of
a directory if more than one file is tagged.  If no files are tagged, you can
either give the name of a directory, or supply a new path and filename to copy
it with a different destination name.
.SH See Also
cat(C), cp(C), ls(C), mv(C), rm(C), setfile(C)
