.TH SX C
.DA 17 May 1992
.SH Name
sx - Send files using XMODEM or YMODEM
.SH Syntax
sx [ _options_ ] _file_...
.SH Description
_Sx_ sends files using XMODEM or YMODEM transfer protocol.  A number of
options control the transfer characteristics:
.IP 5 -b
Binary II mode (Apple II).  This causes _sx_ to wrap files in Binary II
format.  This transmits directory information unique to the file, and required
by the ProDOS operating system.
.IP 5 -c
128-byte blocks with CRC-16.
.IP 5 -d
Double delay tolerance.  This effectively doubles the time that _sx_ allows
for responses over sluggish packet-switched networks.
.IP 5 -f
Send the file's full pathname -- the prefix to the file plus the
file's name.
.IP 5 -k
1K blocks with CRC-16.
.IP 5 -l
4K blocks with CRC-16.
.IP 5 -p
ProDOS mode (Apple II).  Like the Binary II mode, this option employs an
extension unique to some Apple II terminal programs to transfer file
information.  This scheme has been made obsolete by the Binary II standard,
but is included for compatibility with older programs.
.IP 5 -t
Text mode.  This mode converts end of line characters (newlines) to be
compatible with all operating systems.  Include this option whenever text
files are sent to ensure proper newline conversion.  Newline characters
are Control-M in Apple II and Macintosh operating systems, Control-J in UNIX,
and Control-M Control-J in MS-DOS.
.IP 5 -y
YMODEM batch mode with at least 1K blocks and CRC-16.  YMODEM-g is
supported if requested by the receiver.
.IP
Without options, _sx_ sends files in plain 128-byte XMODEM protocol using
checksums for error correction.
.SH See Also
rx(C), rz(C), sz(C)

