.TH TAIL C
.DA 16 May 1992 
.SH Name
tail - Deliver the last part of a file
.SH Syntax
tail [ +|-_number_[_lbc_] ] _file_
.SH Description
_Tail_ copies the named file to the standard output beginning
at a designated place.
.PP
Copying begins at distance +_number_ from the beginning, or
-_number_ from the end of the file.  _Number_ is counted in
units of lines, blocks or characters, according to the
appended option _l_, _b_ or _c_. If no _number_ is specified,
-10 is assumed. When no _unit_ is specified, counting is by lines.
.PP
.PP Examples
.IP 5
.AF
tail logfile
.AF
.IP
Displays the last 10 lines in logfile.
.IP 5
.AF
tail +10 logfile
.AF
.IP
Displays lines from 10 through the end of logfile.
.IP 5
.AF
tail -256c logfile >lastpage
.AF
.IP
Writes the last 256 characters in logfile to the file lastpage.
.SH See Also
cat(C), grep(C)
.SH Notes
Various kinds of anomalous terminal behavior may happen with binary
data files.
