.TH FORWARD F
.DA 16 September 1993
.SH Name
forward - Mail forwarding file
.SH Description
Mail addressed to a local user may be automatically forwarded to
any other e-mail address by creating a file called _forward_ in the
user's home directory ($/usr/username/forward).  This file typically consists
of one line which holds one e-mail address, but multiple lines and multiple
e-mail addresses (space-separated) may also be given.
Forwarding addresses can reference other local or offsite accounts.
.PP
For example, a user on this system named jsbach can create a _forward_ file
that contains this address:
.IP 10
.AF
johann@pro-musette.cts.com
.AF
.IP
Any mail destined for jsbach on this site will effectively be forwarded to
johann@pro-musette.cts.com instead.  Note that the local user jsbach will
_not_ receive a copy of the letter -- it is simply passed onto the forwarding
address.
.PP
To forward a letter and have a copy retained in the local mailbox, include
the user's name, a space (or a new line), and the forwarding address. 
Example:
.IP 10
.AF
jsbach
johann@pro-musette.cts.com
.AF
.IP
Mail addressed to jsbach is copied to jsbach's local mailbox as well as
forward to johann@pro-musette.cts.com.  A number of additional forwarding
addresses can be supplied.
.SH Note
To discontinue forwarding, remove or rename the _forward_ file.
.PP
For loop protection, an address in the forward file cannot reference another
local user that has a _forward_ file.
.SH Files
$/usr/*/forward
.SH See Also
aliases(F), mail(C), sendmail(C)
