' **********************************************************************
' ***
' ***   uuencode.b      Encodes files to be mailed to remote systems
' ***                   (C)opyright 1994 Morgan Davis Group
' ***
' ***   Based on uuencode.c 5.1 (Berkeley) 7/2/83
' ***

#define	IDENT_PROG "uuencode"
#define	IDENT_VERS "3.0"
#define	IDENT_DATE "20jan94"
#define	IDENT_NAME "Morgan_Davis"

#include <proline/proline.h>
#include <prodos.h>

#declare info$, onfo$, inref, AccOK, AccFile$, AccMode, argc, argv$, SysInfo$
#declare p

#define	encode	$300

' ====================
' main
' ====================

        gosub AppInit

        if argc < 3 then
                print "Usage: " argv$[0] " infile outfile"
                goto Exit
        endif

	AccFile$ = argv$[1]
	AccMode = accRead
	gosub CheckAccess
       	& getinfo argv$[1], info$
       	if info$ = "" or not AccOK then
       		print argv$[0] ": can't open " argv$[1]
		goto Exit
       	endif

	& poke encode, \
	    $20,$4C,$E7,$8E,$8B,$03,$20,$00,$BF,$CA,$8A,$03,$C9,$4C,$F0,$09,\
	    $A8,$F0,$07,$20,$8B,$BE,$4C,$09,$BE,$60,$AD,$90,$03,$29,$3F,$18,\
	    $69,$A0,$20,$ED,$FD,$A0,$00,$20,$3A,$03,$C8,$C8,$C8,$CC,$90,$03,\
	    $90,$F5,$A9,$8D,$20,$ED,$FD,$4C,$06,$03,$B9,$80,$02,$4A,$4A,$85
	& poke encode + 64, \
	    $00,$B9,$80,$02,$0A,$0A,$0A,$0A,$29,$30,$85,$01,$B9,$81,$02,$4A,\
	    $4A,$4A,$4A,$29,$0F,$05,$01,$85,$01,$B9,$81,$02,$0A,$0A,$29,$3C,\
	    $85,$02,$B9,$82,$02,$4A,$4A,$4A,$4A,$4A,$4A,$29,$03,$05,$02,$85,\
	    $02,$B9,$82,$02,$29,$3F,$85,$03,$A2,$00,$B5,$00,$29,$3F,$18,$69
	& poke encode + 128, \
	    $A0,$20,$ED,$FD,$E8,$E0,$04,$D0,$F1,$60,$04,$00,$80,$02,$2D,$00,\
	    $00,$00
       	
	fOpen argv$[1] ",T" asc(mid$(info$, 5, 1))
	inref = peek(_OREFNUM)

	AccFile$ = argv$[2]
       	& getinfo AccFile$, onfo$
	AccMode = accWrite + (accDestroy * (onfo$ > ""))
	gosub CheckAccess
       	if not AccOK then
       		print argv$[0] ": can't create " argv$[2]
		goto Exit
       	endif
       	if onfo$ > "" then fDelete argv$[2]
       	fAppend argv$[2]
	
	& pos right$ (argv$[1], "/"), p
	print "begin 644 " mid$(argv$[1], p + 1)
	call encode, inref
	print " ^Mend"
	fClose
goto Exit

#include <proline/proline.lib>
#include <proline/access.lib>



#if 0
*
* uuencode.c	5.1 (Berkeley) 7/2/83
*
* uuencode [input] output
*
* Encode a file so it can be mailed to a remote system.
*

        longa   off
        longi   off
        copy    2/ainclude/mega2.equ
        mcopy   2/ainclude/handy.mac

        org     $300

uuenc   start

buf     equ     $280

        jsr     combyte
        stx     refnum

encode  dos     READ,readpb
        cmp     #$4c
        beq     encrts

        tay
        beq     newbuf

        jsr     $be8b   ;(badcall)
        jmp     errout

encrts  rts

newbuf  lda     n
        and     #$3f
        clc
        adc     #$A0
        jsr     cout
        ldy     #0
loop    jsr     outdec
        iny
        iny
        iny
        cpy     n
        bcc     loop

        putc    #$8d
        jmp     encode

*
* output one group of 3 bytes, pointed at by p, on file f.
*

c1      equ     $00
c2      equ     $01
c3      equ     $02
c4      equ     $03

; c1 = *p >> 2

outdec  lda     buf,y
        lsr     a
        lsr     a
        sta     c1

; c2 = (*p << 4) & 060 | (p[1] >> 4) & 017

        lda     buf,y   ;c2 = (*p << 4) & 060
        asl     a
        asl     a
        asl     a
        asl     a
        and     #$30
        sta     c2
        lda     buf+1,y ; | (p[1] >> 4) & 017
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        and     #$0f
        ora     c2
        sta     c2

; c3 = (p[1] << 2) & 074 | (p[2] >> 6) & 03;

        lda     buf+1,y ;c3 = (p[1] << 2) & 074
        asl     a
        asl     a
        and     #$3c
        sta     c3

        lda     buf+2,y ; | (p[2] >> 6) & 03;
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        and     #$03
        ora     c3
        sta     c3

; c4 = p[2] & 077;

        lda     buf+2,y
        and     #$3f
        sta     c4

        ldx     #0
odloop  lda     c1,x
        and     #$3f
        clc
        adc     #$A0
        jsr     cout
        inx
        cpx     #4
        bne     odloop

        rts

readpb  dc      h'04'
refnum  ds      1
        dc      i'buf'
        dc      i'45'
n       ds      2

        end
#endif
